#include <linux/module.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/slab.h>

MODULE_DESCRIPTION("Allocate memory");
MODULE_AUTHOR("Razvan Deaconescu");
MODULE_LICENSE("GPL");

#define LOG_LEVEL	KERN_ALERT
#define NUM_ROUNDS	8
#define CHUNK_SIZE	(128*1024)

static int alloc_init(void)
{
	size_t i;
	void *p;

	for (i = 0; i < NUM_ROUNDS; i++) {
		p = kmalloc(CHUNK_SIZE, GFP_KERNEL);
		printk("Allocated %d bytes starting from %p.\n",
				CHUNK_SIZE, p);
	}

	return 0;
}

static void alloc_exit(void)
{
}

module_init(alloc_init);
module_exit(alloc_exit);
