#include <linux/module.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/list.h>

MODULE_DESCRIPTION("Print system processes");
MODULE_AUTHOR("Razvan Deaconescu");
MODULE_LICENSE("GPL");

#define LOG_LEVEL	KERN_ALERT

static int pp_init(void)
{
	struct task_struct *p;

	printk(LOG_LEVEL "PID: %d, command: %s\n", current->pid, current->comm);
	list_for_each_entry(p, &current->tasks, tasks)
		printk(LOG_LEVEL "PID: %d, command: %s\n", p->pid, p->comm);

	return 0;
}

static void pp_exit(void)
{
	struct task_struct *p;

	for_each_process(p)
		printk(LOG_LEVEL "PID: %d, command: %s\n", p->pid, p->comm);
}

module_init(pp_init);
module_exit(pp_exit);
