#include <linux/module.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/sched.h>

MODULE_DESCRIPTION("Show message every 5 seconds using workqueues");
MODULE_AUTHOR("Razvan Deaconescu");
MODULE_LICENSE("GPL");

#define SECONDS_TIMEOUT		5
#define LOG_LEVEL		KERN_ALERT

static void show_message(struct work_struct *work)
{
	set_current_state(TASK_UNINTERRUPTIBLE);
	schedule_timeout(SECONDS_TIMEOUT*HZ);
	printk(LOG_LEVEL "Tick in work!\n");
	schedule_work(work);
}

static int tick_init(void)
{
	struct work_struct work;
	INIT_WORK(&work, show_message);
	schedule_work(&work);

	return 0;
}

static void tick_exit(void)
{
	flush_scheduled_work();
}

module_init(tick_init);
module_exit(tick_exit);
